import 'dart:convert';
import 'dart:typed_data';

class B64 {
  final String _base64;

  B64(this._base64);

  @override
  String toString() {
    return _base64;
  }

  Uint8List decode() {
    return base64Url.decode(_base64);
  }

  @override
  int get hashCode => _base64.hashCode;

  @override
  operator ==(Object other) {
    if (other is String) {
      return other == _base64;
    }
    if (other is B64) {
      return other._base64 == _base64;
    }
    return false;
  }

  static B64 encode(List<int> blob) {
    return B64(base64Url.encode(blob));
  }
}
