library utils;

import 'dart:convert';

import 'package:test/test.dart';
import 'package:yona_crypto/b64.dart';
import 'package:yona_crypto/utils.dart';

void main() {
  test("EncodeDecode", () {
    var data = randBytes(200);
    var decoded = B64.encode(data.toList()).decode();
    assert(equal(data, decoded));
  });
  test("Encode", () {
    var orders = [
      ["2f1d49c01e52ddb7875b4b", "MmYxZDQ5YzAxZTUyZGRiNzg3NWI0Yg", false],
      [
        "6b86b273ff34fce19d6b804eff5a3f5747ada4eaa22f1d49c01e52ddb7875b4b",
        "NmI4NmIyNzNmZjM0ZmNlMTlkNmI4MDRlZmY1YTNmNTc0N2FkYTRlYWEyMmYxZDQ5YzAxZTUyZGRiNzg3NWI0Yg==",
        true
      ],
      [
        "ce19d6b804eff5a3f57ada4eaa22f1d49c01e52ddb7875b4b",
        "Y2UxOWQ2YjgwNGVmZjVhM2Y1N2FkYTRlYWEyMmYxZDQ5YzAxZTUyZGRiNzg3NWI0Yg==",
        true
      ]
    ];
    for (var order in orders) {
      var b = B64.encode(utf8.encode(order[0] as String));
      assert((order[1] == b.toString()) == order[2]);
    }
  });
  test("Decode", () {
    var orders = [
      [
        "Y2UxOWQ2YjgwNGVmZjVhM2Y1N2FkYTRlYWEyMmYxZDQ5YzAxZTUyZGRiNzg3NWI0",
        "ZL7E3zc0zzKE3-8lmSS7D1gr96aXcsYfss62WrK7icg",
        false
      ],
      [
        "Y2UxOWQ2YjgwNGVmZjVhM2Y1N2FkYTRlYWEyMmYxZDQ5YzAxZTUyZGRiNzg3NWI0Yg==",
        "ce19d6b804eff5a3f57ada4eaa22f1d49c01e52ddb7875b4b",
        true
      ],
      [
        "NmI4NmIyNzNmZjM0ZmNlMTlkNmI4MDRlZmY1YTNmNTc0N2FkYTRlYWEyMmYxZDQ5YzAxZTUyZGRiNzg3NWI0Yg==",
        "6b86b273ff34fce19d6b804eff5a3f5747ada4eaa22f1d49c01e52ddb7875b4b",
        true
      ]
    ];
    for (var order in orders) {
      var b = B64(order[0] as String).decode();
      assert((order[1] == utf8.decode(b)) == order[2]);
    }
  });
}
